﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace ConsoleConsumer
{
    class Program
    {
        static void Main(string[] args)
        {
            Service1.Service1Client client = new Service1.Service1Client();
            using (OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel))
            {
                MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;
                messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", "kd"));
                messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", "kd"));
            }
            Console.WriteLine("请输入ID：");
           int id =int.Parse ( Console.ReadLine());
            Service1.CallException callException = null;
            try
            {
                
                client.GetByIDWithAuthentication(out callException, id);
                Console.WriteLine("成功调用");
            }
            catch (FaultException<Service1.CallException> ex)
            {
                Console.WriteLine("半路接获CallException Error:{0},{1}", ex.Detail.Message, ex.Detail.Detail);
            }
            catch (FaultException<System.IO.EndOfStreamException> ex)
            {
                Console.WriteLine("半路接获EndOfStreamException Error:{0},{1}", ex.Detail.Message, ex.Detail.HelpLink );
            }
            catch (Exception ex)
            {
                Console.WriteLine("最后一关 Error:{0},{1}", ex.Message, ex.HelpLink);
            }

            Console.Read();
        }
    }
}
