﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.ComponentModel;

namespace WcfConsumer.ViewModels
{
    public class PersonViewModel : INotifyPropertyChanged
    {
        public List<Models.Person> Humans { get; set; }
        public PersonViewModel()
        {
            Humans = new Models.Persons().GetPersons();
            _findCmd = new Commands.PersonFindCommand(this);
        }
        private Models.Person _getOnePerson;

        public Models.Person GetOnePerson
        {
            get { return _getOnePerson; }
            set
            {
                _getOnePerson = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("GetOnePerson"));
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
        private string _findText;

        public string FindText
        {
            get { return _findText; }
            set
            {
                _findText = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("FindText"));
            }
        }
        private List<Models.Person> _findResult;

        public List<Models.Person> FindResult
        {
            get { return _findResult; }
            set
            {
                _findResult = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("FindResult"));
            }
        }
        public void Find()
        {
            List<Models.Person> persons = null;
            if (!string.IsNullOrWhiteSpace(_findText))
            {
                persons =new List<Models.Person>();
                foreach (Models.Person p in Humans)
                {
                    if (p.Name.Contains(_findText))
                        persons.Add(p);
                }
            }
                FindResult = persons;
        }

        private ICommand _findCmd;

        public ICommand FindCmd
        {
            get { return _findCmd; }
        }
        
    }
}
