﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Practices.Unity;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace WcfConsumer
{
    public partial class Home : Page
    {
        public Home()
        {
            InitializeComponent();
        }

        // Executes when the user navigates to this page.
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrWhiteSpace(textBox1.Text))
                return;
            Service1.Service1Client client = new Service1.Service1Client();
            client.GetUserByIDCompleted += new EventHandler<Service1.GetUserByIDCompletedEventArgs>(client_GetUserByIDCompleted);
            using (OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel))
            {
                MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;
                messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", "kd"));
                messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", "kd"));

                client.GetUserByIDAsync(int.Parse(textBox1.Text.Trim()), "123456");
            }
        }

        void client_GetUserByIDCompleted(object sender, Service1.GetUserByIDCompletedEventArgs e)
        {

            #region

            if (e.callException != null)
            {
                ChildWindow win = new ChildWindow();
                win.Title = e.callException.Message;
                win.Content = e.callException.Detail;
                win.MinHeight = 50;
                win.MinWidth = 200;
                win.Show();
            }
            else
            {
                ChildWindow win = new ChildWindow();
                win.Title = "ok";
                win.Content = "it is ok";
                win.MinHeight = 50;
                win.MinWidth = 200;
                win.Show();
            }
            #endregion

        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrWhiteSpace(textBox1.Text))
                return;
            Service1.Service1Client client = new Service1.Service1Client();
            client.GetByIDWithAuthenticationCompleted += new EventHandler<Service1.GetByIDWithAuthenticationCompletedEventArgs>(client_GetByIDWithAuthenticationCompleted);
            using (OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel))
            {
                MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;
                messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", "kd"));
                messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", "kd"));

                client.GetByIDWithAuthenticationAsync(int.Parse(textBox1.Text.Trim()));
            }
        }

        void client_GetByIDWithAuthenticationCompleted(object sender, Service1.GetByIDWithAuthenticationCompletedEventArgs e)
        {
            try
            {
                ErrorWindow errWin = new ErrorWindow("title", "it is ok");
                errWin.Show();
            }
            catch (FaultException<Service1.CallException> ex)
            {
                ErrorWindow errWin = new ErrorWindow(ex.Detail.Message, ex.Detail.Detail);
                errWin.Show();
            }
            catch (Exception ex)
            {
                ErrorWindow errWin = new ErrorWindow(ex);
                errWin.Show();
            }
        }

    }
}