﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.Practices.Unity;
using System.ServiceModel;
using System.IO;

namespace WcfServer.BLL
{

    public class UserBLL : BaseClass.BLLBase
    {
        public UserBLL(Common.DALHelper dalHelper)
        {
            _dalHelper = dalHelper;
        }
        private Common.DALHelper _dalHelper;


        [Common.ExceptionCallHandler("你没有权限", "", "", "你没有权限啊BLL")]
        public User GetByID(int id, out CallException callException)
        {
            callException = null;
            if (id < 10)
            {
                callException = new CallException()
                {
                    Message = "获取用户",
                    Detail = "必须大于等于10"
                };
                throw new FaultException<CallException>(callException, "parameter error");
            }
            else
            {
                User user = null;
                int b = 0;
                user = _dalHelper.UserDal.GetByID(id, ref b, out callException);
                return user;
            }
        }
        [Common.ExceptionCallHandler("你没有权限", "", "", "你没有权限啊BLL")]
        public User GetUserByID(int id, out CallException callException)
        {
            User user = null;
            callException = null;
            if (id < 10)
            {
                callException = new CallException()
                {
                    Message = "获取用户",
                    Detail = "必须大于等于10"
                };
            }
            else
            {
                int b = 0;
                user = _dalHelper.UserDal.GetByID(id, ref b, out callException);
            } return user;
        }
    }

}