﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;
using System.ServiceModel;

namespace WcfServer.Common
{
    public class AuthenticationInvoker : IOperationInvoker
    {

        // InnerOperationInvoker.  Gets set in constructor to have a reference 
        // to the invoker, so we can call when needed.  OperationInvoker comes from the behavior.

        private IOperationInvoker InnerOperationInvoker { get; set; }


        // constructor
        public AuthenticationInvoker(IOperationInvoker operationInvoker)
        {
            this.InnerOperationInvoker = operationInvoker;
        }



        #region IOperationInvoker Members

        public object[] AllocateInputs()
        {

            return InnerOperationInvoker.AllocateInputs();
        }

        public object Invoke(object instance, object[] inputs, out object[] outputs)
        {
            // message header should contain username/password.  Get 'em & authenticate

            MessageHeaders messageHeadersElement = OperationContext.Current.IncomingMessageHeaders;

            // check if headers exist
            // -1 = one is missing, -2 = both are missing
            Int32 id = messageHeadersElement.FindHeader("username", "") + messageHeadersElement.FindHeader("password", "");

            if (id > -1)
            {
                String username = messageHeadersElement.GetHeader<String>("username", "");
                String password = messageHeadersElement.GetHeader<String>("password", "");
                if (username == "kd" && password == "kd")
                {
                    // invoke!
                    return InnerOperationInvoker.Invoke(instance, inputs, out outputs);
                }
            }

            // throw fault  
            throw new FaultException<CallException>(new CallException ("title","Invalid credentials"), "Invalid credentials");

        }

        public IAsyncResult InvokeBegin(object instance, object[] inputs, AsyncCallback callback, object state)
        {
            return InnerOperationInvoker.InvokeBegin(instance, inputs, callback, state);
        }

        public object InvokeEnd(object instance, out object[] outputs, IAsyncResult result)
        {
            return InnerOperationInvoker.InvokeEnd(instance, out outputs, result);
        }

        public bool IsSynchronous
        {
            get { return InnerOperationInvoker.IsSynchronous; }
        }

        #endregion
    }
}