﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.InterceptionExtension;
using System.Reflection;

namespace WcfServer.Common
{
    public class ExceptionCallHandler : ICallHandler
    {
        private string _description;
        private string _procedure;
        private string _modifyTable;

        public string Procedure
        {
            get { return _procedure; }
            set { _procedure = value; }
        }
        public string ModifyTable
        {
            get { return _modifyTable; }
            set { _modifyTable = value; }
        }
        public string Description
        {
            get { return _description; }
            set { _description = value; }
        }
        private string _errorMessage;
        public string ErrorMessage
        {
            get { return _errorMessage; }
            set { this._errorMessage = value; }
        }
        public ExceptionCallHandler(string description, string procedure, string modifyTable,string errorMessage)
        {
            _description = description;
            _procedure = procedure;
            _modifyTable = modifyTable;
            _errorMessage = errorMessage;
        }
        #region ICallHandler Members

        public IMethodReturn Invoke(IMethodInvocation input, GetNextHandlerDelegate getNext)
        {
            if (input == null) throw new ArgumentNullException("input");
            if (getNext == null) throw new ArgumentNullException("getNext");

            IMethodReturn result = getNext()(input, getNext);

            #region 给out参数赋值
            //for (int i = 0; i < input.Arguments.Count; i++)
            //{
            //    if (input.Arguments.GetParameterInfo(i).IsOut)
            //    {
            //        input.Arguments[i] = new CallException()
            //        {
            //            Message = ErrorMessage
            //        };
            //    }
            //}
            #endregion
            //if (result.Exception != null)
            //{
            //    try
            //    {
            //        //LogEntry log = new LogEntry()
            //        //{
            //        //    TimeStamp = DateTime.Now,
            //        //    Message = string.Format("{1};{2}", input.MethodBase.Name, result.Exception.Message, result.Exception.InnerException == null ? "" : result.Exception.InnerException.Message),
            //        //    Categories = GetExceptionCategory()

            //        //};
            //        //log.ExtendedProperties = GetExtendedProperies(input);

            //        //Logger.Write(log);
            //    }
            //    catch { }
            //}
            return result;
        }

        public int Order
        {
            get;

            set;
        }

        #endregion
        private IDictionary<string, object> GetExtendedProperies(IMethodInvocation input)
        {
            IDictionary<string, object> extendedProperties = new Dictionary<string, object>();
            extendedProperties.Add("Method", input.MethodBase.Name);
            if (!string.IsNullOrWhiteSpace(_procedure))
                extendedProperties.Add("SqlProcedure", _procedure);
            if (!string.IsNullOrWhiteSpace(_modifyTable))
                extendedProperties.Add("ModifyTable", _modifyTable);
            extendedProperties.Add("Description", _description);
            PropertyInfo[] ps = null;
            for (int i = 0; i < input.Arguments.Count; i++)
            {
                if (input.Arguments.GetParameterInfo(i).ParameterType.GetCustomAttributes(typeof(UserEntityAttribute), false).Length > 0)
                {
                    ps = input.Arguments.GetParameterInfo(i).ParameterType.GetProperties();
                    foreach (PropertyInfo p in ps)
                    {
                        extendedProperties.Add(p.Name, p.GetValue(input.Arguments[i], null));
                    }
                }
            }
            return extendedProperties;
        }
        private ICollection<string> GetExceptionCategory()
        {
            ICollection<string> categories = new List<string>();
            categories.Add("Exception");
            return categories;
        }
    }
}