﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.InterceptionExtension;

namespace WcfServer.Common
{
    [AttributeUsage(AttributeTargets.Method, AllowMultiple = false)]
    public class ExceptionCallHandlerAttribute : HandlerAttribute
    {
        private string _description;
        private string _procedure;
        private string _modifyTable;
        private string _errorMessage;

        public string ErrorMessage
        {
            get { return _errorMessage; }
            set { _errorMessage = value; }
        }

        public string Procedure
        {
            get { return _procedure; }
            set { _procedure = value; }
        }


        public string ModifyTable
        {
            get { return _modifyTable; }
            set { _modifyTable = value; }
        }
        public string Description
        {
            get { return _description; }
            set { _description = value; }
        }
        public ExceptionCallHandlerAttribute(string description, string procedure, string modifyTable,string errorMessage)
        {
            _errorMessage = errorMessage;
            _description = description;
            _procedure = procedure;
            _modifyTable = modifyTable;
        }
        public ExceptionCallHandlerAttribute(string description)
            : this(description, "", "","")
        {
        }
        public ExceptionCallHandlerAttribute(string description, string procedure)
            : this(description, procedure, "","")
        {
        }
        public override ICallHandler CreateHandler(IUnityContainer container)
        {
            return new ExceptionCallHandler(_description, _procedure, _modifyTable,_errorMessage )
            {
                Order = this.Order
            };
        }
    }
}